// Import Third-party Dependencies
import { match } from "ts-pattern";
import { Nsci } from "../../configuration/standard/index.js";
import * as postPipelineReporting from "./post-pipeline/index.js";
function initializeReporter(reporter) {
    return match(reporter)
        .with(Nsci.reporterTarget.CONSOLE, () => postPipelineReporting.consoleReporter)
        .with(Nsci.reporterTarget.HTML, () => postPipelineReporting.htmlReporter)
        .exhaustive();
}
export async function runReporting(payload, rc) {
    const reportersTasks = rc.reporters.map((reporter) => {
        const { report } = initializeReporter(reporter);
        return report({ ...payload, ...rc });
    });
    await Promise.all(reportersTasks);
}
//# sourceMappingURL=runner.js.map